angular.module('beamng.apps')

.directive('traffic', ['bngApi', function (bngApi) {
	return {
		templateUrl: 'modules/apps/traffic/app.html',
		replace: false,
		restrict: 'E',
		scope: false,
		controller: function ($scope, $element, $attrs) {
			$scope.mainStyle = {appWidth: "100%", appHeight: "100%", inLeft: "auto", inRight: "0px", appShow: "visible", optionsShow: "hidden"};
			$scope.visible = {main: true};
			$scope.inText = "-";
			$scope.unit = "km/h";
			$scope.convert = [2.2369, 3.6];
			$scope.metric = true;
			$scope.quantity = 1;
			$scope.speedLimit = 60;
			$scope.respawn = 1;
			$scope.awareness = true;
			
			$scope.aiModeOptions = ["Нормальный", "Убегать", "Догонять", "Стоп"];
			$scope.debugOptions = ["Выключить", "Цель", "Скорости", "Траектория", "Маршрут"];
			
			this.toggleAll = function() {
				$scope.visible.main = !$scope.visible.main;
				if($scope.visible.main == false) {
					$scope.mainStyle = {appWidth: "16px", appHeight: "16px", inLeft: "0px", inRight: "auto", appShow: "hidden", optionsShow: "hidden"};
					$scope.inText = "+";
				} else {
					$scope.mainStyle = {appWidth: "100%", appHeight: "100%", inLeft: "auto", inRight: "0px", appShow: "visible", optionsShow: "hidden"};
					$scope.inText = "-";
				}
			}
			
			this.showOptions = function() {
				$scope.mainStyle.optionsShow = "visible";
			}
			
			this.setAiMode = function() {
				var command = "extensions.core_multiSpawn.setAiMode('" + this.aiModeOptions + "')";
				bngApi.engineLua(command);
			}	
			
			this.setDebugMode = function() {
				var command = "extensions.core_multiSpawn.setDebugMode('" + this.debugOptions + "')";
				bngApi.engineLua(command);
			}	
			
			this.setSpeedLimit = function() {
				var m = Number($scope.metric);
				var command = "extensions.core_multiSpawn.setSpeedLimit(" + (this.speedLimit / $scope.convert[m]) + ")";
				bngApi.engineLua(command);
			}
			
			this.toggleUnits = function() {
				$scope.metric = !$scope.metric;
				$scope.unit = ($scope.metric) ? "КМ/Ч" : "М/Ч";
				this.setSpeedLimit();
			}
			
			this.setAwareness = function() {
				$scope.awareness = !$scope.awareness;
				var command = "extensions.core_multiSpawn.setAwareness(" + String($scope.awareness) + ")";
				bngApi.engineLua(command);
			}
			
			this.setQuantity = function() {
				var command = "extensions.core_multiSpawn.setQuantity(" + this.quantity + ")";
				bngApi.engineLua(command);
			}
			
			this.setRespawn = function() {
				var command = "extensions.core_multiSpawn.setSpawnIn(" + this.respawn + ") extensions.core_multiSpawn.setSpawnOut(" + this.respawn + ")";
				bngApi.engineLua(command);
			}
			
			this.spawn = function() {
				var command = "extensions.core_multiSpawn.setupVehicles()";
				bngApi.engineLua(command);
			}
			
			this.delete = function() {
				var command = "extensions.core_multiSpawn.deleteVehicles()";
				bngApi.engineLua(command);
			}
			
			this.activate = function() {
				var command = "extensions.core_multiSpawn.startTraffic()";
				bngApi.engineLua(command);
			}
			
			this.deactivate = function() {
				var command = "extensions.core_multiSpawn.stopTraffic()";
				bngApi.engineLua(command);
			}
			
			this.refresh = function() {
				var command = "extensions.core_multiSpawn.refreshVehicles()";
				bngApi.engineLua(command);
			}
			
		},
		controllerAs: 'ctrl'
	};
}]);